env.info("---->Castle Defense Started")

SpawnZoneGroup = GROUP:FindByName( "SpawnArea-1" )
SpawnZone = ZONE_POLYGON:New( "SpawnZone", SpawnZoneGroup )
ZoneTable = { SpawnZone }

PlayerGroups = {"Players-1","Players-2","Players-3","Players-4"}

Zone1 = ZONE:FindByName("Explode-1")
Zone2 = ZONE:FindByName("Explode-2")
Zone3 = ZONE:FindByName("Explode-3")
Zone4 = ZONE:FindByName("Explode-4")
Zone5 = ZONE:FindByName("Explode-5")
Zone6 = ZONE:FindByName("Explode-6")

ActiveZones = {1,2,3,4,5,6}

Flag1 = USERFLAG:New(1)
Flag2 = USERFLAG:New(2)
Flag3 = USERFLAG:New(3)
Flag4 = USERFLAG:New(4)
Flag5 = USERFLAG:New(5)
Flag6 = USERFLAG:New(6)
GameStartFlag = USERFLAG:New(7)
GameOverFlag = USERFLAG:New(8)
NewRoundFlag = USERFLAG:New(9)
TruckExplodeFlag = USERFLAG:New(10)

--EventHandler1 = EVENTHANDLER:New()
EventHandler3 = EVENTHANDLER:New()
--EventHandler1:HandleEvent( EVENTS.Hit )
EventHandler3:HandleEvent( EVENTS.Crash )

Kami = {}

KamiGroup = SPAWN:New( "Kami" )
  :InitRandomizeZones( ZoneTable )
  
WaveNr = 0
SpeedTimeout = 10
TimeOutArray = {}
Score = 0
HitList = {}

function Init ()
  GameStartFlag:Set(1,0)
  BuildMenu()
  SetupStartWave()
  CheckZones()
  MainCheckLoop()
  FirstWave = true
  NextWave()

end

function NextWave()

  env.info("---->NextWave")
  
  -- play newwavesound only on second and next waves.
  if FirstWave == true then
    FirstWave = false
  else
    NewRoundFlag:Set(1,0)
  end

  WaveNr = WaveNr + 5
  TaskingMessage("NextWave Activated!, Starting Engines..",15,false)
  TaskingMessage("Number of kamikaze busses: "..WaveNr,15,false)
  SpawnWave(WaveNr)
  SetRandomWaypoints(WaveNr)

  
  

end

function MainCheckLoop()

  MainScheduler = SCHEDULER:New( nil,
    function()

      --code to be repeated here
      if CheckDefenseTargets() then
      CheckAllAttackersDead(WaveNr)
      CheckNoMovement()
      DestroyDamagedAttackers()
      end

    end,
    {}, 0, 10 ) -- 0=start, 1=repeattime

end

function SetupStartWave()
  
  local NumberOfPlayers = GetNumberOfPlayers()
  
  if 2 <= NumberOfPlayers then
    WaveNr = WaveNr + (NumberOfPlayers * 5)
  end
  
end

function GameOver()
  env.info("---->GameOver")

  MainScheduler:Stop()
  ZonesScheduler:Stop()
  
  
  TaskingMessage("GameOver",15,false)
  GameOverFlag:Set(1,0)
  TaskingMessage("Score: "..Score, 120,false)

end

function BuildMenu()

  --Cleanup = MENU_COALITION_COMMAND:New( coalition.side.BLUE, "Cleanup Wave", nil, CheckNoMovement)
  ShowScoreMenu = MENU_COALITION_COMMAND:New( coalition.side.BLUE, "Show Score", nil, ShowScore)
  _SETTINGS:SetPlayerMenuOff()
  
end

function CleanWave()

  local SpeedZero
  for i = 1,WaveNr do
    SpeedZero = CheckGroupSpeedZero(Kami[i])
    if SpeedZero == true then
      Kami[i]:Destroy()
    end
  end
  
end

function CheckGroupSpeedZero(Group)

  local Speed = Group:GetVelocityKNOTS()
  env.info("---->Group "..Group.GroupName.." is at "..Speed)
  if not ( 10 <= Speed) then
    env.info("---->Speed 0 detected on unit "..Group.GroupName)
    return true
  else
    return false
  end
  
end

function CheckNoMovement()
env.info("---->CheckNoMovement")

  local GroupsMoving = false
  local GroupsStuck = false
  local SpeedZero


  if #Kami ~= WaveNr then -- prevents cleanup at the start of the wave. 
    for i = 1,WaveNr do

      SpeedZero = CheckGroupSpeedZero(Kami[i])

      if SpeedZero == true then
        GroupsStuck = true
      else
        GroupsMoving = true
      end

    end
  end
  if GroupsStuck == true and GroupsMoving == false then

    TaskingMessage("All movement has stopped. Stuck units Detected. cleaning.....",15,false)
    CleanWave()
    
  end

  if  GroupsMoving == true then
  
    env.info( "---->groups are still moving. cleanup denied" )
    
  end

end

function DestroyDamagedAttackers()
env.info("---->DestroyDamagedAttackers")
  for i = 1,WaveNr do
    Damaged = CheckAttackerDamage(Kami[i])
    

    if Damaged == true then

      local unit = Kami[i]:GetUnits()
      unit[1]:Explode(500,0)
      TruckExplodeFlag:Set(1,0)
      unit[1]:Destroy()
      Score = Score + 10
      ShowScore()
      
    end
  end

end

function CheckAttackerDamage(group)

  if group:IsAlive() then
    local Health = group:GetLife()
    if Health ~= 2 then
      return true
    else
      return false
    end
  else
    return false
  end
end

--function EventHandler1:OnEventHit( EventData )
--
--  local NameInTable = false
--  local TargetName = EventData.TgtUnit.UnitName
--  local IsPlayer = CheckIsPlayerGroup(EventData.IniGroupName)
--  local unit = UNIT:FindByName(TargetName)
--  local group = unit:GetGroup()
--  
--  if IsPlayer then
--    env.info("---->Player Shot something")
--    if CheckAttackerDamage(group) then -- only check explosion possible once
--
--      local RandomNumber = math.random(1, 2)
--
--      if RandomNumber == 1 then
--
--        unit:Explode(500,0)
--        TruckExplodeFlag:Set(1,0)
--        unit:Destroy()
--        env.info("---->explode on hit called")
--        Score = Score + 10
--        ShowScore()
--      end
--    else
--      env.info("---->target already damaged")
--    end
--  end
--
--
--  -- todo: randomize explosion. soms wel soms niet. anders vertragen via checkdead functie
--  -- sound effects. explosion triggered explosie geluid
--
--
--end

function EventHandler3:OnEventCrash( EventData )
  env.info("---->crash called")

  local IsPlayer = CheckIsPlayerGroup(EventData.IniGroupName)
  if IsPlayer then
    Score = Score - 50
    TaskingMessage("Player Crashed. Score Penalty - 50",15,false)
    ShowScore()
  end
end

function CheckIsPlayerGroup (groupname)

  for key,value in ipairs (PlayerGroups) do
    if value == groupname then
      return true
    end
    return false
  end
end

function GetNumberOfPlayers()

  SetClient = SET_CLIENT:New():FilterActive(Active):FilterCoalitions("blue"):FilterStart()
  local PlayerCount = SetClient:Count()
  return PlayerCount

end

function ShowScore()

  TaskingMessage("Score: "..Score, 15,false)

end

function CheckZones()

  ZonesScheduler = SCHEDULER:New( nil,
    function()
      --code to be repeated here
      for i=1,WaveNr do
        if Kami[i]:IsCompletelyInZone( Zone1 ) then
          env.info("---->Explode 1")
          Flag1:Set(1,0)
          UpdateWaypoints(1)
        end
      end
      
       for i=1,WaveNr do
        if Kami[i]:IsCompletelyInZone( Zone2 ) then
          env.info("---->Explode 2")
          Flag2:Set(1,0)
          UpdateWaypoints(2)
        end
      end
      
       for i=1,WaveNr do
        if Kami[i]:IsCompletelyInZone( Zone3 ) then
          env.info("---->Explode 3")
          Flag3:Set(1,0)
          UpdateWaypoints(3)
        end
      end
      
       for i=1,WaveNr do
        if Kami[i]:IsCompletelyInZone( Zone4 ) then
          env.info("---->Explode 4")
          Flag4:Set(1,0)
          UpdateWaypoints(4)
        end
      end
      
       for i=1,WaveNr do
        if Kami[i]:IsCompletelyInZone( Zone5 ) then
          env.info("---->Explode 5")
          Flag5:Set(1,0)
          UpdateWaypoints(5)
        end
      end
      
       for i=1,WaveNr do
        if Kami[i]:IsCompletelyInZone( Zone6 ) then
          env.info("---->Explode 6")
          Flag6:Set(1,0)
          UpdateWaypoints(6)
        end
      end

    end,
    {}, 0, 1 ) -- 0=start, 1=repeattime

end

function CheckDefenseTargets()
env.info("---->CheckDefenseTargets")

  local Alive = false
  local TargetAlive = false
  for i = 1,6 do
    local Target = STATIC:FindByName("Static Chemical tank A-"..i,false)
    if Target ~= nil then
      TargetAlive = Target:IsAlive()
      if TargetAlive == true then Alive = true end
    end
  end

  if Alive == false then
    MainScheduler:Stop()
    GameOver()
    return false
  end
  return true
end

function CheckAllAttackersDead()
  env.info("---->CheckAllAttackersDead")

  local AliveCount = 0
  local Alive = false
  if 0 < #Kami then
    for i = 1,WaveNr do
      local GroupAlive = Kami[i]:IsAlive()
      if GroupAlive == true then
        AliveCount = AliveCount +1
        Alive = true end
    end

    TaskingMessage("Remaining Attackers: "..AliveCount,10,false)

    if Alive == false then
      NextWave()
    end
  end

end

function UpdateWaypoints(WaypointNr)
-- function called when a zone explodes. Updates waypoints for groups that had the explode target and reassigns.
env.info("---->update waypoints")
  
  -- find the key for the Waypoint to remove. when removed, indexes no longer match the values in the table.b je 
  for key,value in ipairs(ActiveZones) do
    if WaypointNr == value then
      table.remove(ActiveZones,key)
    end
  end
  
  for i=1,WaveNr do
    if Kami[i].AssignedZone == WaypointNr and Kami[i]:IsAlive() then
      env.info("---->updateing waypoint for"..Kami[i].GroupName)
      SetZoneAsWaypoint(i)
    end
  end

end

function SetRandomWaypoints()
env.info("---->Switch")
  
  for i=1,WaveNr do
    SetZoneAsWaypoint(i)
  end
  
end

function SetZoneAsWaypoint(Nr)

    ZoneNr = math.random(1, #ActiveZones)
    local Zone = ZONE:New("Explode-"..ActiveZones[ZoneNr])
    local ZoneCoord = Zone:GetCoordinate()
    Kami[Nr]:RouteGroundTo(ZoneCoord,40,"Vee",20)
    Kami[Nr].AssignedZone = ZoneNr
    
end

function SpawnWave()
  
  Kami = {}
  for i=1,WaveNr do
    Kami[i] = KamiGroup:Spawn()
  end

end

function TaskingMessage(message,time,clear)

  local MCMessage = MESSAGE:New( message, time , nil ) -- replace nil with ie "notify", message will then begin with "notify: <message>"
  if clear == true then MCMessage:Clear() end-- clear previous messages on screen
  --MCMessage:ToGroup(group)
  MCMessage:ToAll() --debugging

end



Init()


env.info("---->Castle Defense Ended")